package com.zfire.jiasm.syncdata.service;

import com.zfire.jiasm.syncdata.plus.entity.*;
import com.zfire.jiasm.syncdata.response.WebsitFWS;
import com.zfire.jiasm.syncdata.response.WebsitSH;

import java.util.Date;
import java.util.List;
import java.util.Map;

public interface PublicService {

    // 创建工单师傅数据
    OrderWorker getOrderWorker(OrderBase orderBase);
    // 获取工单师傅数据
    List<OrderWorker> getWorker(String workerId,String orderBaseId);
    // 移除工单师傅数据
    void deleteWorker(String orderBaseId);
    // 提取品牌商对应的大类信息
    Map<String, List<SysDictRef>> getStringListMap(Brand brand);
    // 提取品牌商对应的小类信息
    Map<String, List<SysDictRef>> getListMap(Brand brand);
    // 提取品牌商对应的系列信息
    Map<String, List<SysDictRef>> getMap(Brand brand);
    // 提取品牌商对应的需求大类信息
    Map<String, List<SysDictRef>> getStringListMapXq(Brand brand);
    // 提取品牌商对应的需求小类信息
    Map<String, List<SysDictRef>> getListMapXq(Brand brand);
    // 提取品牌商对应的需求小类信息
    Map<String, List<SysDictRef>> getListMapXqtoPP(Brand brand);
    // 提取品牌商对应的需求类别信息
    Map<String, List<SysDict>> getStringListMapXqLb();
    // 获取平台服务网点热线电话
    String getSHWDPhone(String websitNo);
    // 单号，主键，同步任务生成时间，同步的表名，工单类型，任务类型
    OutJiasmToGreeUploadTaskList getUploadTaskListLog(String orderNo, String id, Date updateTime, String itemTableName, String itemOrderType, int i);
    // 单号，主键，同步任务生成时间，同步的表名，工单类型，任务类型
    OutJiasmToGreeUploadTaskList getUploadTaskList(String orderNo, String id, Date updateTime, String itemTableName, String itemOrderType, int i);
    // 单号，主键，同步任务生成时间，同步的表名，工单类型，任务类型
    OutJiasmToGreeUploadTaskList getUploadTaskList(String orderNo, String id, String itemTableName, String itemOrderType, int i);
    // 获取短信发送码
    String getfsma();
    // 修改数据上传任务表同步状态
    void updateUploadTaskListStatus(String orderNo, Long synReqId,Integer synStatus,Integer uploadTaskType);
    // 修改数据上传任务表同步状态
    void updateUploadTaskLisError(OutJiasmToGreeUploadTaskList ojtutl, String msg);


    // 商户销售网点对应平台销售网点
    WebsitFWS shxswdToptxswd(String websitNo, String category);
    // 商户售后网点对应平台售后网点 orderBase为平台内的信息
    WebsitFWS shshwdToptshwd(String websitNo, String category);

    // 获取商户网点信息(销售与售后网点信息)
    WebsitSH merchantWebsitInfoX(String websitNo,String type);

    // 平台销售网点对应商户销售网点
    WebsitSH  ptxswdToshxswd(String websitNo, String category);
    // 平台售后网点对应商户售后网点 为平台内的信息
    WebsitSH  ptshwdToshshwd(String websitNo, String mainId);

}
